'/* ------------------------------------------------------------------ */
'/* Decimal Number Library Demonstration program                       */
'/* ------------------------------------------------------------------ */
'/* Copyright (c) IBM Corporation, 2001.  All rights reserved.         */
'/* ----------------------------------------------------------------+- */
'/*                                                 right margin -->|  */

'// example4.c -- add two numbers, active error handling

#define DECNUMDIGITS 38                         ' work with up to 38 digits

#include once "decNumber/decContext.bi"
#include once "decNumber/decNumber.bi"
#include once "decNumber/decQuad.bi"
'#include once "decNumber/decimal128.bi"

dim as decNumber one, mtwo, hundred       ' constants
dim as decNumber start, rate, years       ' parameters
dim as decNumber total                    ' result
dim as decContext set                     ' working context
'dim as string s1, s2, s3
dim as zstring ptr buffer, errmsg, s1, s2, s3
dim as decquad nq

buffer = allocate(DECNUMDIGITS+16) ' conversion buffer
errmsg = allocate(80)
s1 = allocate(80)
s2 = allocate(80)
s3 = allocate(80)
decContextDefault (@set, DEC_INIT_BASE)   ' initialize
set.traps = 0                             ' no traps
set.digits = 25                           ' precision 25
decNumberFromString (@one,      "1", @set)' set constants
decNumberFromString (@mtwo,    "-2", @set)
decNumberFromString (@hundred,"100", @set)
Print "Enter Starting amount  "
Input *s1
decNumberFromString (@start, s1, @set)
Print "Enter Interest Rate    "
Input *s2
decNumberFromString (@rate, s2, @set)
Print "Enter Number Of Years  "
Input *s3
decNumberFromString (@years, s3, @set)
If (set.status and DEC_Errors) then
    Print "Invalid input"
    Print "press return key to end";
    sleep
    deallocate(buffer)
    deallocate(errmsg)
    deallocate(s1)
    deallocate(s2)
    deallocate(s3)
End
EndIf
decNumberDivide(@rate, @rate, @hundred, @set)  ' rate=rate/100
decNumberAdd(@rate, @rate, @one, @set)         ' rate=rate+1
decNumberPower(@rate, @rate, @years, @set)     ' rate=rate^years
decNumberMultiply(@total, @rate, @start, @set) ' total=rate*start
decNumberRescale(@total, @total, @mtwo, @set)  ' two digits please

If (set.status and DEC_Errors) then
    set.status = set.status and DEC_Errors        ' keep only errors
    errmsg = decContextStatusToString(@set)  
    Print "Result could not be calculated "
    Print *errmsg
    Print "press return key to end";
    sleep
    deallocate(buffer)
    deallocate(errmsg)
    deallocate(s1)
    deallocate(s2)
    deallocate(s3)
    End
EndIf
decNumberToString (@total, buffer)
Print *s1+" dollars at "+*s2+"% interest rate for "+*s3+" years "+" => "+*buffer+" dollars"

'decimal128FromNumber.l (nq, total, @set)
'decimal128ToString (@nq, *buffer)
'PrintN(PeekS(*buffer))

Print "press return key to end";
sleep
deallocate(buffer)
deallocate(errmsg)
deallocate(s1)
deallocate(s2)
deallocate(s3)
