''
''
'' decContext -- header translated with help of SWIG FB wrapper
''
'' NOTICE: This file is part of the FreeBASIC Compiler package and can't
''         be included in other distributions without authorization.
''
''
#ifndef __decContext_bi__
#define __decContext_bi__

#inclib "decNumber"

#define uint8_t ubyte
#define uint16_t ushort
#define int32_t integer
#define uint32_t uinteger


#define DECCNAME "decContext"
#define DECCFULLNAME "Decimal Context Descriptor"
#define DECCAUTHOR "Mike Cowlishaw"
#define DECEXTFLAG 1
#define DECSUBSET 0

enum rounding
	DEC_ROUND_CEILING
	DEC_ROUND_UP
	DEC_ROUND_HALF_UP
	DEC_ROUND_HALF_EVEN
	DEC_ROUND_HALF_DOWN
	DEC_ROUND_DOWN
	DEC_ROUND_FLOOR
	DEC_ROUND_05UP
	DEC_ROUND_MAX
end enum

type decContext
	digits as int32_t
	emax as int32_t
	emin as int32_t
	round as rounding
	traps as uint32_t
	status as uint32_t
	clamp as uint8_t
end type

#define DEC_MAX_DIGITS 999999999
#define DEC_MIN_DIGITS 1
#define DEC_MAX_EMAX 999999999
#define DEC_MIN_EMAX 0
#define DEC_MAX_EMIN 0
#define DEC_MIN_EMIN -999999999
#define DEC_MAX_MATH 999999

enum decClass
	DEC_CLASS_SNAN
	DEC_CLASS_QNAN
	DEC_CLASS_NEG_INF
	DEC_CLASS_NEG_NORMAL
	DEC_CLASS_NEG_SUBNORMAL
	DEC_CLASS_NEG_ZERO
	DEC_CLASS_POS_ZERO
	DEC_CLASS_POS_SUBNORMAL
	DEC_CLASS_POS_NORMAL
	DEC_CLASS_POS_INF
end enum

#define DEC_ClassString_SN "sNaN"
#define DEC_ClassString_QN "NaN"
#define DEC_ClassString_NI "-Infinity"
#define DEC_ClassString_NN "-Normal"
#define DEC_ClassString_NS "-Subnormal"
#define DEC_ClassString_NZ "-Zero"
#define DEC_ClassString_PZ "+Zero"
#define DEC_ClassString_PS "+Subnormal"
#define DEC_ClassString_PN "+Normal"
#define DEC_ClassString_PI "+Infinity"
#define DEC_ClassString_UN "Invalid"
#define DEC_Conversion_syntax &h00000001
#define DEC_Division_by_zero &h00000002
#define DEC_Division_impossible &h00000004
#define DEC_Division_undefined &h00000008
#define DEC_Insufficient_storage &h00000010
#define DEC_Inexact &h00000020
#define DEC_Invalid_context &h00000040
#define DEC_Invalid_operation &h00000080
#define DEC_Overflow &h00000200
#define DEC_Clamped &h00000400
#define DEC_Rounded &h00000800
#define DEC_Subnormal &h00001000
#define DEC_Underflow &h00002000
#define DEC_IEEE_754_Division_by_zero (&h00000002)
#define DEC_IEEE_754_Inexact (&h00000020)
#define DEC_IEEE_754_Invalid_operation (&h00000001 or &h00000004 or &h00000008 or &h00000010 or &h00000040 or &h00000080)
#define DEC_IEEE_754_Overflow (&h00000200)
#define DEC_IEEE_754_Underflow (&h00002000)
#define DEC_Errors ((&h00000002) or (&h00000001 or &h00000004 or &h00000008 or &h00000010 or &h00000040 or &h00000080) or (&h00000200) or (&h00002000))
#define DEC_NaNs (&h00000001 or &h00000004 or &h00000008 or &h00000010 or &h00000040 or &h00000080)
#define DEC_Information (&h00000400 or &h00000800 or &h00000020)
#define DEC_IEEE_854_Division_by_zero (&h00000002)
#define DEC_IEEE_854_Inexact (&h00000020)
#define DEC_IEEE_854_Invalid_operation (&h00000001 or &h00000004 or &h00000008 or &h00000010 or &h00000040 or &h00000080)
#define DEC_IEEE_854_Overflow (&h00000200)
#define DEC_IEEE_854_Underflow (&h00002000)
#define DEC_Condition_CS "Conversion syntax"
#define DEC_Condition_DZ "Division by zero"
#define DEC_Condition_DI "Division impossible"
#define DEC_Condition_DU "Division undefined"
#define DEC_Condition_IE "Inexact"
#define DEC_Condition_IS "Insufficient storage"
#define DEC_Condition_IC "Invalid context"
#define DEC_Condition_IO "Invalid operation"
#define DEC_Condition_OV "Overflow"
#define DEC_Condition_PA "Clamped"
#define DEC_Condition_RO "Rounded"
#define DEC_Condition_SU "Subnormal"
#define DEC_Condition_UN "Underflow"
#define DEC_Condition_ZE "No status"
#define DEC_Condition_MU "Multiple status"
#define DEC_Condition_Length 21
#define DEC_INIT_BASE 0
#define DEC_INIT_DECIMAL32 32
#define DEC_INIT_DECIMAL64 64
#define DEC_INIT_DECIMAL128 128
#define DEC_INIT_DECSINGLE 32
#define DEC_INIT_DECDOUBLE 64
#define DEC_INIT_DECQUAD 128

declare function decContextClearStatus cdecl alias "decContextClearStatus" (byval as decContext ptr, byval as uint32_t) as decContext ptr
declare function decContextDefault cdecl alias "decContextDefault" (byval as decContext ptr, byval as int32_t) as decContext ptr
declare function decContextGetRounding cdecl alias "decContextGetRounding" (byval as decContext ptr) as rounding
declare function decContextGetStatus cdecl alias "decContextGetStatus" (byval as decContext ptr) as uint32_t
declare function decContextRestoreStatus cdecl alias "decContextRestoreStatus" (byval as decContext ptr, byval as uint32_t, byval as uint32_t) as decContext ptr
declare function decContextSaveStatus cdecl alias "decContextSaveStatus" (byval as decContext ptr, byval as uint32_t) as uint32_t
declare function decContextSetRounding cdecl alias "decContextSetRounding" (byval as decContext ptr, byval as rounding) as decContext ptr
declare function decContextSetStatus cdecl alias "decContextSetStatus" (byval as decContext ptr, byval as uint32_t) as decContext ptr
declare function decContextSetStatusFromString cdecl alias "decContextSetStatusFromString" (byval as decContext ptr, byval as zstring ptr) as decContext ptr
declare function decContextSetStatusFromStringQuiet cdecl alias "decContextSetStatusFromStringQuiet" (byval as decContext ptr, byval as zstring ptr) as decContext ptr
declare function decContextSetStatusQuiet cdecl alias "decContextSetStatusQuiet" (byval as decContext ptr, byval as uint32_t) as decContext ptr
declare function decContextStatusToString cdecl alias "decContextStatusToString" (byval as decContext ptr) as zstring ptr
declare function decContextTestEndian cdecl alias "decContextTestEndian" (byval as uint8_t) as int32_t
declare function decContextTestSavedStatus cdecl alias "decContextTestSavedStatus" (byval as uint32_t, byval as uint32_t) as uint32_t
declare function decContextTestStatus cdecl alias "decContextTestStatus" (byval as decContext ptr, byval as uint32_t) as uint32_t
declare function decContextZeroStatus cdecl alias "decContextZeroStatus" (byval as decContext ptr) as decContext ptr

#endif
