''
''
'' decNumber -- header translated with help of SWIG FB wrapper
''
'' NOTICE: This file is part of the FreeBASIC Compiler package and can't
''         be included in other distributions without authorization.
''
''
#ifndef __decNumber_bi__
#define __decNumber_bi__

#define DECNAME "decNumber"
#define DECFULLNAME "Decimal Number Module"
#define DECAUTHOR "Mike Cowlishaw"
#define DECNEG &h80
#define DECINF &h40
#define DECNAN &h20
#define DECSNAN &h10
#define DECSPECIAL (&h40 or &h20 or &h10)
#define DECDPUN 3
#ifndef DECNUMDIGITS
    #define DECNUMDIGITS 1
#endif
#define DECNUMUNITS ((DECNUMDIGITS+DECDPUN-1)/DECDPUN)

'type decNumber
'	digits as int32_t
'	exponent as int32_t
'	bits as uint8_t
'	lsu(0 to ((DECNUMDIGITS+DECDPUN-1)/DECDPUN)-1) as uint16_t
'end type
#define function_overload 1 ' set to 0 if you don't want to overload
                            ' the functions log, exp, sqr, abs
                            ' int, frac, fix and sgn
                            
                            ' don't like the way it's done in the
                            ' present version but future versions
                            ' of FB will likely allow function
                            ' overloading without undefining
                            ' the native functions first.
'====================================================================
type decNumber
	digits as int32_t
	exponent as int32_t
	bits as uint8_t
	lsu(0 to ((DECNUMDIGITS+DECDPUN-1)/DECDPUN)-1) as uint16_t
 
	Declare constructor ( Byref rhs As decNumber )
	Declare constructor ( Byref rhs As String ="0" )
	Declare constructor ( Byref rhs As Double )
	Declare constructor ( Byref rhs As Longint )
	Declare constructor ( Byref rhs As uLongint )
	Declare constructor ( Byref rhs As integer )
	Declare constructor ( Byref rhs As uinteger )

	Declare operator let( byref rhs As decNumber )
	Declare operator let( byref rhs As String )
	Declare operator let( byval rhs As Double )
	Declare operator let( byval rhs As Longint )
	'' implicit step versions
	Declare Operator For ( )
	Declare Operator Step( )
	Declare Operator Next( Byref end_cond As decNumber ) As Integer
    
	'' explicit step versions
	Declare Operator For ( Byref step_var As decNumber )
	Declare Operator Step( Byref step_var As decNumber )
	Declare Operator Next( Byref end_cond As decNumber, Byref step_var As decNumber ) As Integer
        
	Declare Operator += (byref rhs as decNumber)
	Declare Operator -= (byref rhs as decNumber)

	Declare operator cast( ) As String
	Declare operator cast( ) As Double
End type
'====================================================================


declare function decNumberFromInt32 cdecl alias "decNumberFromInt32" (byval as decNumber ptr, byval as int32_t) as decNumber ptr
declare function decNumberFromUInt32 cdecl alias "decNumberFromUInt32" (byval as decNumber ptr, byval as uint32_t) as decNumber ptr
declare function decNumberFromString cdecl alias "decNumberFromString" (byval as decNumber ptr, byval as zstring ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberToString cdecl alias "decNumberToString" (byval as decNumber ptr, byval as zstring ptr) as zstring ptr
declare function decNumberToEngString cdecl alias "decNumberToEngString" (byval as decNumber ptr, byval as zstring ptr) as zstring ptr
declare function decNumberToUInt32 cdecl alias "decNumberToUInt32" (byval as decNumber ptr, byval as decContext ptr) as uint32_t
declare function decNumberToInt32 cdecl alias "decNumberToInt32" (byval as decNumber ptr, byval as decContext ptr) as int32_t
declare function decNumberGetBCD cdecl alias "decNumberGetBCD" (byval as decNumber ptr, byval as uint8_t ptr) as uint8_t ptr
declare function decNumberSetBCD cdecl alias "decNumberSetBCD" (byval as decNumber ptr, byval as uint8_t ptr, byval as uint32_t) as decNumber ptr
declare function decNumberAbs cdecl alias "decNumberAbs" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberAdd cdecl alias "decNumberAdd" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberAnd cdecl alias "decNumberAnd" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberCompare cdecl alias "decNumberCompare" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberCompareSignal cdecl alias "decNumberCompareSignal" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberCompareTotal cdecl alias "decNumberCompareTotal" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberCompareTotalMag cdecl alias "decNumberCompareTotalMag" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberDivide cdecl alias "decNumberDivide" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberDivideInteger cdecl alias "decNumberDivideInteger" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberExp cdecl alias "decNumberExp" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberFMA cdecl alias "decNumberFMA" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberInvert cdecl alias "decNumberInvert" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberLn cdecl alias "decNumberLn" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberLogB cdecl alias "decNumberLogB" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberLog10 cdecl alias "decNumberLog10" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberMax cdecl alias "decNumberMax" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberMaxMag cdecl alias "decNumberMaxMag" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberMin cdecl alias "decNumberMin" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberMinMag cdecl alias "decNumberMinMag" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberMinus cdecl alias "decNumberMinus" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberMultiply cdecl alias "decNumberMultiply" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberNormalize cdecl alias "decNumberNormalize" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberOr cdecl alias "decNumberOr" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberPlus cdecl alias "decNumberPlus" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberPower cdecl alias "decNumberPower" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberQuantize cdecl alias "decNumberQuantize" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberReduce cdecl alias "decNumberReduce" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberRemainder cdecl alias "decNumberRemainder" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberRemainderNear cdecl alias "decNumberRemainderNear" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberRescale cdecl alias "decNumberRescale" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberRotate cdecl alias "decNumberRotate" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberSameQuantum cdecl alias "decNumberSameQuantum" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr) as decNumber ptr
declare function decNumberScaleB cdecl alias "decNumberScaleB" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberShift cdecl alias "decNumberShift" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberSquareRoot cdecl alias "decNumberSquareRoot" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberSubtract cdecl alias "decNumberSubtract" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberToIntegralExact cdecl alias "decNumberToIntegralExact" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberToIntegralValue cdecl alias "decNumberToIntegralValue" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberXor cdecl alias "decNumberXor" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberClass cdecl alias "decNumberClass" (byval as decNumber ptr, byval as decContext ptr) as decClass
declare function decNumberClassToString cdecl alias "decNumberClassToString" (byval as decClass) as zstring ptr
declare function decNumberCopy cdecl alias "decNumberCopy" (byval as decNumber ptr, byval as decNumber ptr) as decNumber ptr
declare function decNumberCopyAbs cdecl alias "decNumberCopyAbs" (byval as decNumber ptr, byval as decNumber ptr) as decNumber ptr
declare function decNumberCopyNegate cdecl alias "decNumberCopyNegate" (byval as decNumber ptr, byval as decNumber ptr) as decNumber ptr
declare function decNumberCopySign cdecl alias "decNumberCopySign" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr) as decNumber ptr
declare function decNumberNextMinus cdecl alias "decNumberNextMinus" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberNextPlus cdecl alias "decNumberNextPlus" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberNextToward cdecl alias "decNumberNextToward" (byval as decNumber ptr, byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr) as decNumber ptr
declare function decNumberTrim cdecl alias "decNumberTrim" (byval as decNumber ptr) as decNumber ptr
declare function decNumberVersion cdecl alias "decNumberVersion" () as zstring ptr
declare function decNumberZero cdecl alias "decNumberZero" (byval as decNumber ptr) as decNumber ptr
declare function decNumberIsNormal cdecl alias "decNumberIsNormal" (byval as decNumber ptr, byval as decContext ptr) as int32_t
declare function decNumberIsSubnormal cdecl alias "decNumberIsSubnormal" (byval as decNumber ptr, byval as decContext ptr) as int32_t

'====================================================================
declare function decLnOp cdecl alias "decLnOp" (byval as decNumber ptr, byval as decNumber ptr, byval as decContext ptr, byval as uinteger ptr) as decNumber ptr
declare function decCheckMath cdecl alias "decCheckMath" (byval as const decNumber ptr, byval as decContext ptr, byval as uinteger ptr) as uinteger
'====================================================================

'Declare Function cdecNumber Overload ( Byref lhs As decNumber ) As decNumber
'Declare Function cdecNumber ( Byref lhs As String )  As decNumber
'
'Function cdecNumber ( Byref lhs As decNumber ) As decNumber
'    Return lhs
'End Function
'
'Function cdecNumber ( Byref rhs As String ) As decNumber
'    Dim As decNumber retval
'    Dim As decContext set
'    decContextDefault (@set, DEC_INIT_BASE)
'    set.digits = DECNUMDIGITS
'    decNumberFromString (@retval,rhs, @set)
'    Return retval
'End Function

Operator + ( Byref lhs As decNumber, Byref rhs As decNumber ) As decNumber
    Dim As decNumber retval
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberAdd(@retval, @lhs, @rhs, @set )
    Return retval
End Operator

'=============================================================
Operator decNumber.+= ( byref rhs as decNumber )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberAdd(@this, @this, @rhs, @set )
End Operator
'=============================================================

Operator - ( Byref lhs As decNumber, Byref rhs As decNumber ) As decNumber
    Dim As decNumber retval
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberSubtract( @retval, @lhs, @rhs, @set )
    Return retval
End Operator

'=============================================================
Operator decNumber.-= ( byref rhs as decNumber )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberSubtract(@this, @this, @rhs, @set )
End Operator
'=============================================================

Operator - ( Byref lhs As decNumber ) As decNumber
    dim as decNumber z
    decNumberCopyNegate (@z, @lhs)
    operator = z
End Operator

Operator * ( Byref lhs As decNumber, Byref rhs As decNumber ) As decNumber
    Dim As decNumber retval
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberMultiply(@retval, @lhs, @rhs, @set )
    Return retval
End Operator

Operator / ( Byref lhs As decNumber, Byref rhs As decNumber ) As decNumber
    Dim As decNumber retval
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberDivide(@retval, @lhs, @rhs, @set )
    Return retval
End Operator

Operator ^ (Byref x As decNumber, Byval yy As Longint) As decNumber
Dim As decNumber power, product
Dim As Longint y, term
Dim As Integer sign_y = 0   ' positive    
If yy = 0 Then Return "1." ' anything to the power of zero is one    
If yy < 0 Then  ' test for negative sign of exponent
    y = -yy
    sign_y = 1
Else
    y = yy
    sign_y = 0
End If
product = 1     ' build product from a binary power series
power = x       ' compute x^(2^n) for all bits set in y
term = 1
Do
    If (y And term) Then
        product = product * power
        y = y And Not(term) ' kill the term bit just done
    End If
    If y = 0 Then Exit Do   ' all bits are now done
    power = power * power
    term = term + term
Loop        ' exit was when y became zero
If sign_y = 1 Then
    Return 1 / product
Else
    Return product
End If
End Operator

Operator ^ (Byref x As decNumber, Byval y As Integer) As decNumber
    Dim As Longint yy = Clng(y)
    Return x ^ yy
End Operator

'=============================================================
function dec_Abs (Byref x as decNumber) as decNumber
    dim as decNumber y
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberAbs (@y, @x, @set)
    return y 
end function

function bcd_Neg (Byref x as decNumber) as decNumber
    dim as decNumber y
    decNumberCopyNegate (@y, @x)
    return y 
end function

function compare ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    Dim as decNumber comp
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberCompare (@comp, @lhs, @rhs, @set)
    relop=decNumberToInt32 (@comp, @set)
    Return relop
End function

Operator = ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    relop=compare(lhs,rhs)
    Return relop=0
End Operator

Operator <> ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    relop=compare(lhs,rhs)
    Return relop<>0
End Operator

Operator < ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    relop=compare(lhs,rhs)
    Return relop<0
End Operator

Operator > ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    relop=compare(lhs,rhs)
    Return relop>0
End Operator

Operator <= ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    relop=compare(lhs,rhs)
    Return relop<=0
End Operator

Operator >= ( Byref lhs As decNumber, Byref rhs As decNumber ) As Integer
    Dim As integer relop
    relop=compare(lhs,rhs)
    Return relop>=0
End Operator

'=============================================================

Operator decNumber.cast ( ) As String
    Dim zs As Zstring Ptr
    zs = allocate(DECNUMDIGITS+16)
    decNumberToString (@this, zs)
    Operator = *zs
    deallocate(zs)
End Operator

Operator decNumber.cast ( ) As Double
    Dim zs As Zstring Ptr
    zs = allocate(DECNUMDIGITS+16)
    decNumberToString (@this, zs)
    Operator = val(*zs)
    deallocate(zs)
End Operator

constructor decNumber ( Byref rhs As decNumber )
	this = rhs
end constructor

constructor decNumber ( Byref rhs As String )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, rhs, @set)
end constructor

constructor decNumber ( Byref rhs As Double )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end constructor

constructor decNumber ( Byref rhs As Longint )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end constructor

constructor decNumber ( Byref rhs As uLongint )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end constructor

constructor decNumber ( Byref rhs As integer )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end constructor

constructor decNumber ( Byref rhs As uinteger )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end constructor

operator decNumber.let ( Byref rhs As decNumber )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberCopy (@this, @rhs)
end operator

operator decNumber.let ( Byref rhs As String )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, rhs, @set)
end operator

operator decNumber.let ( Byval rhs As Double )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end operator

operator decNumber.let ( Byval rhs As Longint )
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromString (@this, str(rhs), @set)
end operator

'=========================================================
'' For Next for decNumber type
''
'' implicit step versions
'' 
'' In this example, we interpret implicit step
'' to mean 1
Operator decNumber.for( )
End Operator
 
Operator decNumber.step( )
        this += 1 'this = this+1 '
End Operator 
 
Operator decNumber.next( Byref end_cond As decNumber ) As Integer
        Return this <= end_cond
End Operator
 
 
'' explicit step versions
'' 
Operator decNumber.for( Byref step_var As decNumber )
End Operator
 
Operator decNumber.step( Byref step_var As decNumber )
        this += step_var 'this = this + step_var '    
End Operator 
 
Operator decNumber.next( Byref end_cond As decNumber, Byref step_var As decNumber ) As Integer
        If step_var < 0 Then
                Return this >= end_cond
        Else
                Return this <= end_cond
        End If
End Operator

'=============================================================
'=================================================================
' Square root function and exponentiation operator
'=================================================================
#if function_overload
Function Sqr_(Byval x As Double) As Double
    Return Sqr(x)
End Function

#undef Sqr

Function Sqr Overload(Byval x As Double) As Double
    Return Sqr_(x)
End Function

Function Sqr Overload(Byref x As decNumber) As decNumber
    Dim As decNumber y
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberSquareRoot (@y, @x, @set)
    Return y
End Function

Function Log_(Byval x As Double) As Double
    Return Log(x)
End Function

#undef Log

Function Log Overload(Byval x As Double) As Double
    Return Log_(x)
End Function

Function Log Overload(Byref x As decNumber) As decNumber
    Dim As decNumber y=x
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    set.emax = DEC_MAX_MATH
    set.emin = -DEC_MAX_MATH
    decNumberLn (@y, @y, @set)
    Return y
End Function

Function EXP_(Byval x As Double) As Double
    Return Exp(x)
End Function

#undef Exp

Function Exp Overload(Byval x As Double) As Double
    Return EXP_(x)
End Function

Function Exp Overload(Byref x As decNumber) As decNumber
    Dim As decNumber y=x
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    set.emax = DEC_MAX_MATH
    set.emin = -DEC_MAX_MATH
    decNumberExp (@y, @y, @set)
    Return y
End Function

Function Abs_(Byval x As Double) As Double
    Return Abs(x)
End Function
#undef Abs
Function Abs Overload (Byval x As Double) As Double
    Return abs_(x)
End Function

Function Abs Overload (Byref x As decNumber) As decNumber
    dim as decNumber y
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberAbs (@y, @x, @set)
    return y
End Function

'----------------------------------------------------------------
Function Int_(Byval x As Double) As Double
    Return Int(x)
End Function
#undef Int
Function Int Overload (Byval x As Double) As Double
    Return Int_(x)
End Function

Function Int Overload (Byref x As decNumber) As decNumber
    Dim As decNumber y
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    set.round=DEC_ROUND_FLOOR
    decNumberToIntegralValue (@y, @x, @set)
    return y
End Function

Function Frac_(Byval x As Double) As Double
    Return Frac(x)
End Function
#undef Frac
Function Frac Overload (Byval x As Double) As Double
    Return Frac_(x)
End Function

Function Frac Overload (Byref x As decNumber) As decNumber
    Dim As decNumber y,z
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    set.round=DEC_ROUND_FLOOR
    decNumberAbs (@z, @x, @set)
    decNumberToIntegralValue (@y, @z, @set)
    decNumberSubtract (@y, @z, @y, @set)
    decNumberCopySign (@y, @y, @x)
    return y
End Function

Function Fix_(Byval x As Double) As Double
    Return Fix(x)
End Function
#undef Fix
Function Fix Overload (Byval x As Double) As Double
    Return Fix_(x)
End Function

Function Fix Overload (Byref x As decNumber) As decNumber
    Dim As decNumber y
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    set.round=DEC_ROUND_FLOOR
    decNumberAbs (@y, @x, @set)
    decNumberToIntegralValue (@y, @y, @set)
    decNumberCopySign (@y, @y, @x)
    return y
End Function

Function Sgn_(Byval x As Double) As Double
    Return Sgn(x)
End Function
#undef Sgn
Function Sgn Overload (Byval x As Double) As Double
    Return Sgn_(x)
End Function

Function Sgn Overload (Byref x As decNumber) As Double
    Dim As integer relop
    Dim as decNumber comp
    Dim As decContext set
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    decNumberFromInt32 (@comp, 0)
    decNumberCompare (@comp, @x, @comp, @set)
    relop=decNumberToInt32 (@comp, @set)
    Return relop
End Function
#endif
'====================================================================

#endif
