''
''
'' decQuad -- header translated with help of SWIG FB wrapper
''
'' NOTICE: This file is part of the FreeBASIC Compiler package and can't
''         be included in other distributions without authorization.
''
''
#ifndef __decQuad_bi__
#define __decQuad_bi__

#define DECQUADNAME "decimalQuad"
#define DECQUADTITLE "Decimal 128-bit datum"
#define DECQUADAUTHOR "Mike Cowlishaw"
#define DECQUAD_Bytes 16
#define DECQUAD_Pmax 34
#define DECQUAD_Emin -6143
#define DECQUAD_Emax 6144
#define DECQUAD_EmaxD 4
#define DECQUAD_Bias 6176
#define DECQUAD_String 43
#define DECQUAD_EconL 12
#define DECQUAD_Declets 11
#define DECQUAD_Ehigh (6144+6176-(34-1))

union decQuad
	bytes(0 to DECQUAD_Bytes-1) as uint8_t
	shorts(0 to DECQUAD_Bytes/2-1) as uint16_t
	words(0 to DECQUAD_Bytes/4-1) as uint32_t
end union

#define DECFLOAT_Sign &h80000000
#define DECFLOAT_NaN &h7c000000
#define DECFLOAT_qNaN &h7c000000
#define DECFLOAT_sNaN &h7e000000
#define DECFLOAT_Inf &h78000000
#define DECFLOAT_MinSp &h78000000
#define DECPPLUSALT &h0A
#define DECPMINUSALT &h0B
#define DECPPLUS &h0C
#define DECPMINUS &h0D
#define DECPPLUSALT2 &h0E
#define DECPUNSIGNED &h0F

declare function decQuadFromBCD cdecl alias "decQuadFromBCD" (byval as decQuad ptr, byval as int32_t, byval as uint8_t ptr, byval as int32_t) as decQuad ptr
declare function decQuadFromInt32 cdecl alias "decQuadFromInt32" (byval as decQuad ptr, byval as int32_t) as decQuad ptr
declare function decQuadFromPacked cdecl alias "decQuadFromPacked" (byval as decQuad ptr, byval as int32_t, byval as uint8_t ptr) as decQuad ptr
declare function decQuadFromPackedChecked cdecl alias "decQuadFromPackedChecked" (byval as decQuad ptr, byval as int32_t, byval as uint8_t ptr) as decQuad ptr
declare function decQuadFromString cdecl alias "decQuadFromString" (byval as decQuad ptr, byval as zstring ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadFromUInt32 cdecl alias "decQuadFromUInt32" (byval as decQuad ptr, byval as uint32_t) as decQuad ptr
declare function decQuadGetCoefficient cdecl alias "decQuadGetCoefficient" (byval as decQuad ptr, byval as uint8_t ptr) as int32_t
declare function decQuadGetExponent cdecl alias "decQuadGetExponent" (byval as decQuad ptr) as int32_t
declare function decQuadSetCoefficient cdecl alias "decQuadSetCoefficient" (byval as decQuad ptr, byval as uint8_t ptr, byval as int32_t) as decQuad ptr
declare function decQuadSetExponent cdecl alias "decQuadSetExponent" (byval as decQuad ptr, byval as decContext ptr, byval as int32_t) as decQuad ptr
declare sub decQuadShow cdecl alias "decQuadShow" (byval as decQuad ptr, byval as zstring ptr)
declare function decQuadToBCD cdecl alias "decQuadToBCD" (byval as decQuad ptr, byval as int32_t ptr, byval as uint8_t ptr) as int32_t
declare function decQuadToEngString cdecl alias "decQuadToEngString" (byval as decQuad ptr, byval as zstring ptr) as zstring ptr
declare function decQuadToInt32 cdecl alias "decQuadToInt32" (byval as decQuad ptr, byval as decContext ptr, byval as rounding) as int32_t
declare function decQuadToInt32Exact cdecl alias "decQuadToInt32Exact" (byval as decQuad ptr, byval as decContext ptr, byval as rounding) as int32_t
declare function decQuadToPacked cdecl alias "decQuadToPacked" (byval as decQuad ptr, byval as int32_t ptr, byval as uint8_t ptr) as int32_t
declare function decQuadToString cdecl alias "decQuadToString" (byval as decQuad ptr, byval as zstring ptr) as zstring ptr
declare function decQuadToUInt32 cdecl alias "decQuadToUInt32" (byval as decQuad ptr, byval as decContext ptr, byval as rounding) as uint32_t
declare function decQuadToUInt32Exact cdecl alias "decQuadToUInt32Exact" (byval as decQuad ptr, byval as decContext ptr, byval as rounding) as uint32_t
declare function decQuadZero cdecl alias "decQuadZero" (byval as decQuad ptr) as decQuad ptr
declare function decQuadAbs cdecl alias "decQuadAbs" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadAdd cdecl alias "decQuadAdd" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadAnd cdecl alias "decQuadAnd" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadDivide cdecl alias "decQuadDivide" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadDivideInteger cdecl alias "decQuadDivideInteger" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadFMA cdecl alias "decQuadFMA" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadInvert cdecl alias "decQuadInvert" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadLogB cdecl alias "decQuadLogB" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadMax cdecl alias "decQuadMax" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadMaxMag cdecl alias "decQuadMaxMag" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadMin cdecl alias "decQuadMin" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadMinMag cdecl alias "decQuadMinMag" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadMinus cdecl alias "decQuadMinus" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadMultiply cdecl alias "decQuadMultiply" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadNextMinus cdecl alias "decQuadNextMinus" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadNextPlus cdecl alias "decQuadNextPlus" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadNextToward cdecl alias "decQuadNextToward" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadOr cdecl alias "decQuadOr" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadPlus cdecl alias "decQuadPlus" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadQuantize cdecl alias "decQuadQuantize" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadReduce cdecl alias "decQuadReduce" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadRemainder cdecl alias "decQuadRemainder" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadRemainderNear cdecl alias "decQuadRemainderNear" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadRotate cdecl alias "decQuadRotate" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadScaleB cdecl alias "decQuadScaleB" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadShift cdecl alias "decQuadShift" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadSubtract cdecl alias "decQuadSubtract" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadToIntegralValue cdecl alias "decQuadToIntegralValue" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr, byval as rounding) as decQuad ptr
declare function decQuadToIntegralExact cdecl alias "decQuadToIntegralExact" (byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadXor cdecl alias "decQuadXor" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadCompare cdecl alias "decQuadCompare" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadCompareSignal cdecl alias "decQuadCompareSignal" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr, byval as decContext ptr) as decQuad ptr
declare function decQuadCompareTotal cdecl alias "decQuadCompareTotal" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadCompareTotalMag cdecl alias "decQuadCompareTotalMag" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadCanonical cdecl alias "decQuadCanonical" (byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadCopy cdecl alias "decQuadCopy" (byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadCopyAbs cdecl alias "decQuadCopyAbs" (byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadCopyNegate cdecl alias "decQuadCopyNegate" (byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadCopySign cdecl alias "decQuadCopySign" (byval as decQuad ptr, byval as decQuad ptr, byval as decQuad ptr) as decQuad ptr
declare function decQuadClass cdecl alias "decQuadClass" (byval as decQuad ptr) as decClass
declare function decQuadClassString cdecl alias "decQuadClassString" (byval as decQuad ptr) as zstring ptr
declare function decQuadDigits cdecl alias "decQuadDigits" (byval as decQuad ptr) as uint32_t
declare function decQuadIsCanonical cdecl alias "decQuadIsCanonical" (byval as decQuad ptr) as uint32_t
declare function decQuadIsFinite cdecl alias "decQuadIsFinite" (byval as decQuad ptr) as uint32_t
declare function decQuadIsInteger cdecl alias "decQuadIsInteger" (byval as decQuad ptr) as uint32_t
declare function decQuadIsInfinite cdecl alias "decQuadIsInfinite" (byval as decQuad ptr) as uint32_t
declare function decQuadIsNaN cdecl alias "decQuadIsNaN" (byval as decQuad ptr) as uint32_t
declare function decQuadIsNormal cdecl alias "decQuadIsNormal" (byval as decQuad ptr) as uint32_t
declare function decQuadIsSignaling cdecl alias "decQuadIsSignaling" (byval as decQuad ptr) as uint32_t
declare function decQuadIsSignalling cdecl alias "decQuadIsSignalling" (byval as decQuad ptr) as uint32_t
declare function decQuadIsSigned cdecl alias "decQuadIsSigned" (byval as decQuad ptr) as uint32_t
declare function decQuadIsSubnormal cdecl alias "decQuadIsSubnormal" (byval as decQuad ptr) as uint32_t
declare function decQuadIsZero cdecl alias "decQuadIsZero" (byval as decQuad ptr) as uint32_t
declare function decQuadRadix cdecl alias "decQuadRadix" (byval as decQuad ptr) as uint32_t
declare function decQuadSameQuantum cdecl alias "decQuadSameQuantum" (byval as decQuad ptr, byval as decQuad ptr) as uint32_t
declare function decQuadVersion cdecl alias "decQuadVersion" () as zstring ptr

#endif
